function [ ret ] = compute_nmi( z, zref )
% Input: z, zref: real n x 1

    n = size(z, 1);
    K1 = max(zref);
    K2 = max(z);
    
    I = 0;
    for i = 1:K1
        for j = 1:K2
            num1 = sum(zref == i * ones(n, 1));
            num2 = sum(z == j * ones(n, 1));
            num12 = sum((zref == i * ones(n, 1)) .* (z == j * ones(n, 1)));
            if (num12 > 0)
                I = I + num12/n * log(n * num12 / (num1 * num2));
            end
        end
    end
    
    H1 = 0;
    for i = 1:K1
        num = sum(zref == i * ones(n, 1));
        if (num > 0)
            H1 = H1 - num/n * log(num/n);
        end
    end
    
    H2 = 0;
    for i = 1:K2
        num = sum(z == i * ones(n, 1));
        if (num > 0)
            H2 = H2 - num/n * log(num/n);
        end
    end
    
    ret = I / (0.5 * (H1 + H2));

end

