% Hopkins 155 -- 2 motions

lambdas = [0.001 0.0025 0.005 0.01 0.025 0.05 0.1 0.25 0.5 1.0 2.5 5.0 10 25 50 100];
ss = [0.01 0.025 0.05 0.1 0.25 0.5 1.0 2.5 5.0 10 25 50 100];

% read the index
T = 117;
default_K = 2;
default_d = 3;
dirs = {};
%f = fopen('Hopkins155\\traffic_twomotion.txt', 'r');
%f = fopen('Hopkins155\\check_twomotion.txt', 'r');
%f = fopen('Hopkins155\\articul_twomotion.txt', 'r');
f = fopen('Hopkins155/all_twomotion.txt', 'r');
for i = 1:T
    s = fgetl(f);
    dirs{i} = s;
end
fclose(f);

err = zeros(3, T);
totd = zeros(2, T);
totK = zeros(2, T);

for t = 1:T
   
    name = dirs{t};
    fprintf('Processing case %s\n', name);
    
    % read and preprocess the data
    load(['Hopkins155/' name '/' name '_truth.mat']);
    [x0, y0] = preprocess_hopkins(x, r, s);
    
    % Do cross-validation
    para_lambda = 10;
    para_s = 0.5;
    max_acc = 0;
    x_cv = x0(1:int32(size(x0, 1) * rate) ,:);
    y_cv = y0(1:size(x_cv, 1));
    flag = 0;
    for i = 1:size(lambdas, 2)
        for j = 1:size(ss, 2)
            [z1, K1, w_ret, mu_ret, d_ret] = dpspace(x0, lambdas(i), ss(j), 1, 5, 100, 1e-4, 1);
            acc = evaluate_biclustering(z1(1:size(y_cv, 1)), y_cv);
            if (acc > max_acc)
                max_acc = acc;
                para_lambda = lambdas(i);
               % para_s = ss(j) / rate;
                para_s = ss(j);
            end
        end
    end
    fprintf('para_lambda = %f, para_s = %f, max_acc = %f\n', para_lambda, para_s, max_acc);
    
    % Run DP-space
    [z1, K1, w_ret, mu_ret, d_ret] = dpspace(x0, para_lambda, para_s, 1, 5, 100, 1e-4, 1);
    acc = evaluate_biclustering(z1, y0);
    err(1, t) = (1.0 - acc) * 100;
    [totK(1, t), totd(1, t)] = report_wo_outliers(z1, d_ret, 0.05);
    fprintf('DP-space: K1=%d, meand=%f, err=%f\n',  totK(1, t), totd(1, t), err(1, t));
%     
    % Run MPPCA
    M = 10;
    tacc = zeros(1, M);
    for m = 1:M
        [z2, Pi, W, mu, sigmasq] = em_mppca(x0, default_K, default_d * ones(default_K, 1), 100, 1e-4);
        tacc(m) = evaluate_biclustering(z2, y0);
    end
    err(2, t) = (1.0 - mean(tacc)) * 100;
    err(3, t) = (1.0 - max(tacc)) * 100;
    
end
