% batch running for ransac on Hopkins 155

sumTime = 0;

T = 117;
f = fopen('Hopkins155\\all_twomotion.txt', 'r');
for i = 1:T
    s = fgetl(f);
    dirs{i} = s;
end
fclose(f);

r = 5;

for t = 1:T
   
    name = dirs{t};
    fprintf('Processing case %s\n', name);
    
    % read and preprocess the data
    load(['Hopkins155\\' name '\\' name '_truth.mat']);
    [x0, y0] = preprocess_hopkins(x, r, s);
    
    tt = cputime;
    [group, b] = ransac_subspaces(x0', 4, 2, 0.01);
    sumTime = sumTime + cputime - tt;
    
end

T = 34;
f = fopen('Hopkins155\\all_threemotion.txt', 'r');
for i = 1:T
    s = fgetl(f);
    dirs{i} = s;
end
fclose(f);

r = 5;

for t = 1:T
   
    name = dirs{t};
    fprintf('Processing case %s\n', name);
    
    % read and preprocess the data
    load(['Hopkins155\\' name '\\' name '_truth.mat']);
    [x0, y0] = preprocess_hopkins(x, r, s);
    
    tt = cputime;
    [group, b] = ransac_subspaces(x0', 4, 3, 0.01);
    sumTime = sumTime + cputime - tt;
    
end