% Yale Face B

lambdas = [0.001 0.0025 0.005 0.01 0.025 0.05 0.1 0.25 0.5 1.0 2.5 5.0 10 25 50 100];
ss = [0.01 0.025 0.05 0.1 0.25 0.5 1.0 2.5 5.0 10 25 50 100];
T1 = size(lambdas, 2);
T2 = size(ss, 2);

z_ref = [ones(64, 1); 2 * ones(64, 1)];

errs = zeros(T1, T2);
Ks = zeros(T1, T2);

for t1 = 1:T1
    for t2 = 1:T2
        
        lambda = lambdas(t1);
        s = ss(t2);
        
        [z, K] = dpspace_batch(Y', lambda, s, 1, 10, 30, 1e-3);
        Ks(t1, t2) = K;
        errs(t1, t2) = evaluate_biclustering(z, z_ref);
        
        disp([lambda s Ks(t1, t2) errs(t1, t2)]);
        
    end
end